'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRequiredIf = require('react-required-if');

var _reactRequiredIf2 = _interopRequireDefault(_reactRequiredIf);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const uuidv4 = () => {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, c => {
    var r = Math.random() * 16 | 0,
        v = c == 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
};

class GridifierItem extends _react2.default.Component {
  constructor(props) {
    super(props);
    this.state = { id: this.props.id || uuidv4() };
  }

  getClassNames() {
    return (0, _classnames2.default)('rg-grid-item', this.props.className);
  }

  getWrapperClassNames() {
    return 'rg-item-wrapper';
  }

  getStyles() {
    return { visibility: 'hidden' };
  }

  getDimensions() {
    return 'N/A';
  }

  render() {
    return _react2.default.createElement(
      'div',
      {
        className: this.getClassNames(), 'data-dimensions': this.getDimensions(),
        key: this.state.id, id: this.state.id, style: this.getStyles()
      },
      _react2.default.createElement(
        'div',
        { className: this.getWrapperClassNames() },
        this.props.children
      ),
      this.props.draggable ? this.getDragHandler() : null,
      this.getMoreHandlers(),
      this.props.removable ? this.getRemoveHandler() : null
    );
  }

  getDragHandler() {
    return _react2.default.createElement('div', { className: 'rg-drag-handler rg-edition-tool' });
  }

  getRemoveHandler() {
    return _react2.default.createElement('div', { className: 'rg-remove-handler rg-edition-tool', onClick: () => this.props.removeHandler(this) });
  }

  getMoreHandlers() {
    return null;
  }
}

GridifierItem.propTypes = {
  id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  draggable: _propTypes2.default.bool.isRequired,
  removable: _propTypes2.default.bool.isRequired,
  removeHandler: (0, _reactRequiredIf2.default)(_propTypes2.default.func, props => props.removable)
};

GridifierItem.defaultProps = {
  id: null,
  draggable: false,
  removable: false
};

exports.default = GridifierItem;